/************************************************************************************/
/*  Program name CAPFNDEXT_CONC_PROG_PARAM_TL.sql                                   */
/*  Creater:  NIP Karen (PCCW - UniHub)                                             */
/*************   History   *************************                                */
/* 12 JAN, 2005   NIP Karen         First created                                   */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
SET VERIFY OFF

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFNDEXT_CONC_PROG_PARAM_TL';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPFND_CONC_PROG_PARAM_TL.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		FDFCUT.*
	FROM
		FND_CONCURRENT_PROGRAMS			FCP,
		FND_CONCURRENT_PROGRAMS_TL		FCPT,
		FND_DESCR_FLEX_COL_USAGE_TL		FDFCUT
	WHERE	FCP.Application_ID						=	FCPT.Application_ID
	AND		FCP.Concurrent_Program_ID				=	FCPT.Concurrent_Program_ID
	AND		FCPT.Language							=	'US'
	AND		SUBSTR(FCPT.User_Concurrent_Program_Name,1,4)	=	p_NGO
	AND		FCP.Application_ID						=	FDFCUT.Application_ID
	AND		'$SRS$.'||FCP.Concurrent_Program_Name	=	FDFCUT.Descriptive_Flexfield_Name
	ORDER BY
		FCP.Application_ID,
		FCP.Concurrent_Program_Name,
		FDFCUT.Descriptive_Flexfield_Name,
		FDFCUT.Application_Column_Name;

BEGIN
	lv_NGO_Name		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.Application_ID||CHR(9)||
				C1.Descriptive_Flexfield_Name||CHR(9)||
				C1.Descriptive_Flex_Context_Code||CHR(9)||
				C1.Application_Column_Name||CHR(9)||
				C1.Language||CHR(9)||
				C1.Last_Update_Date||CHR(9)||
					C1.Last_Updated_By||CHR(9)||
				C1.Creation_Date||CHR(9)||
					C1.Created_By||CHR(9)||
				C1.Last_Update_Login||CHR(9)||
				C1.Form_Left_Prompt||CHR(9)||
				C1.Form_Above_Prompt||CHR(9)||
				C1.Description||CHR(9)||
				C1.Source_Lang||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.LAST_UPDATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.CREATED_BY)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
		IF	lv_Scc_Count	=	0	THEN
			lv_Err_Msg	:=	lv_NGO_Name||': No Concurrent Program Parameter TL for this NGO';
		END IF;
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
